routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('/posts','PostController');

Route::group(['prefix'=>'comments'], function(){
    Route::get('{comment}/like','CommentController@like');
    Route::get('{comment}/unlike','CommentController@unlike');
    Route::post('{post}','CommentController@store');
    Route::get('{post}/parent/{comment}','CommentController@create');
});

Route::group(['prefix'=>'wp-admin','namespace'=>'Admin','middleware'=>['auth','admin']], function(){
    Route::get('/','AdminController@index');
    Route::resource('/posts','PostController');
});

Route::get('/category/{category}','CategoryController@index');

Route::get('/user/posts','UserController@posts')->middleware('auth');
Route::get('/user/favorites','UserController@favorites')->middleware('auth')->name('users.favorites');

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Str;

class Post extends Model
{
    protected $with = ['categories','author'];

    protected $fillable = ['title','content','author_id'];

    public function author(){
        return $this->belongsTo(User::class, 'author_id','id');
    }

    public function comments(){
        return $this->hasMany(Comment::class);
    }

    public function categories(){
        return $this->belongsToMany(Category::class);
    }

    public function parent_comments(){
        return $this->hasMany(Comment::class)->where('parent', 0);
    }

    public function getPreviewAttribute(){
        return Str::limit($this->content, 150);
    }
}

app/Http/Controllers/Admin/PostController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Post;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Session;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $where = [];
        $query = Post::with('author');
        if(request()->title){
            $where[] = ['title','LIKE','%'.request()->title.'%'];
        }
        if(request()->author){
            $query->whereHas('author', function ($q){
                $q->where('name','LIKE','%'.request()->author.'%');
            });
        }
        if(request()->date){
            $where[] = ['created_at','>', date('Y-m-d H:i:s', strtotime(request()->date))];
        }
        $posts = $query->where($where)->orderBy('id','DESC')->paginate(env('PER_PAGE'));

        return view('admin.posts.index', compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.posts.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title'=>'required|string',
            'categories'=>'required|array',
            'textcontent'=>'nullable|string'
        ]);

        $post = Post::create([
            'title' => $request->title,
            'content' => $request->textcontent,
            'author_id' => auth()->user()->id
        ]);

        $post->categories()->sync($request->categories, true);

        if($post){
            Session::flash('success',__('Post created'));
            return redirect('/wp-admin/posts');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        return view('admin.posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        $cats = $post->categories->pluck('id')->toArray();

        return view('admin.posts.edit', compact('post', 'cats'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Post $post)
    {
        $request->validate([
            'title'=>'required|string',
            'categories'=>'required|array',
            'textcontent'=>'nullable|string'
        ]);

        $post->title = $request->title;
        $post->content = $request->textcontent;

        $post->categories()->sync($request->categories, true);

        if($post->save()){
            Session::flash('success',__('Post updated'));
            return redirect('/wp-admin/posts');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {

        $post->delete();

        Session::flash('danger',__('Post deleted'));

        return redirect()->back();
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use Illuminate\Http\Request;

class PostController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth',['except'=>['index','show']]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $where = [];
        $query = Post::with('author');
        if(request()->title){
            $where[] = ['title','LIKE','%'.request()->title.'%'];
        }
        if(request()->author){
            $query->whereHas('author', function ($q){
                $q->where('name','LIKE','%'.request()->author.'%');
            });
        }
        if(request()->date){
            $where[] = ['created_at','>', date('Y-m-d H:i:s', strtotime(request()->date))];
        }
        $posts = $query->where($where)->orderBy('id','DESC')->paginate(env('PER_PAGE'));

        return view('posts.index', compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('posts.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title'=>'required|string',
            'categories'=>'required|array',
            'textcontent'=>'nullable|string'
        ]);

        $post = Post::create([
            'title' => $request->title,
            'content' => $request->textcontent,
            'author_id' => auth()->user()->id
        ]);

        $post->categories()->sync($request->categories, true);

        if($post){
            return redirect('/posts');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        $this->authorize('edit', $post);
        $cats = $post->categories->pluck('id')->toArray();

        return view('posts.edit', compact('post', 'cats'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Post $post)
    {
        $this->authorize('edit', $post);
        $request->validate([
            'title'=>'required|string',
            'categories'=>'required|array',
            'textcontent'=>'nullable|string'
        ]);

        $post->title = $request->title;
        $post->content = $request->textcontent;

        $post->categories()->sync($request->categories, true);

        if($post->save()){
            return redirect('/user/posts');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {
        $this->authorize('edit', $post);

        $post->delete();

        return redirect()->back();
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-12">
                <h1>{{__('Create post')}}</h1>
                <form method="post" action="/posts">
                    @csrf
                    <div class="form-group">
                        <label for="title">{{__('Title')}}</label>
                        <input type="text" name="title" class="form-control" id="title" />
                        @if($errors->has('title'))
                            <span class="text-danger">{{ $errors->first('title') }}</span>
                        @endif
                    </div>
                    <div class="form-group">
                        <label for="textcontent">{{__('Content')}}</label>
                        <textarea name="textcontent" class="form-control" id="textcontent"></textarea>
                        @if($errors->has('textcontent'))
                            <span class="text-danger">{{ $errors->first('textcontent') }}</span>
                        @endif
                    </div>
                    <div class="form-group">
                        @if($categories->count())
                        <ul class="list-unstyled list-inline">
                            @foreach($categories as $category)
                                <li class="list-inline-item">
                                    <input type="checkbox" name="categories[]" value="{{ $category->id }}"> {{ $category->name }}
                                </li>
                            @endforeach
                        </ul>
                        @endif
                            @if($errors->has('categories'))
                                <span class="text-danger">{{ $errors->first('categories') }}</span>
                            @endif
                    </div>
                    <div class="form-group text-center">
                        <button type="submit" class="btn btn-outline-success btn-lg">{{__('Save post')}}</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-12">
                <h1>{{__('Edit post')}}</h1>
                <form method="post" action="/posts/{{ $post->id }}">
                    @csrf
                    @method('PUT')
                    <div class="form-group">
                        <label for="title">{{__('Title')}}</label>
                        <input type="text" name="title" class="form-control" value="{{ $post->title }}" id="title" />
                        @if($errors->has('title'))
                            <span class="text-danger">{{ $errors->first('title') }}</span>
                        @endif
                    </div>
                    <div class="form-group">
                        <label for="textcontent">{{__('Content')}}</label>
                        <textarea name="textcontent" class="form-control" id="textcontent">{{ $post->content }}</textarea>
                        @if($errors->has('textcontent'))
                            <span class="text-danger">{{ $errors->first('textcontent') }}</span>
                        @endif
                    </div>
                    <div class="form-group">
                        @if($categories->count())
                            <ul class="list-unstyled list-inline">
                                @foreach($categories as $category)
                                    <li class="list-inline-item">
                                        <input type="checkbox" name="categories[]" @if(in_array($category->id, $cats)) checked @endif value="{{ $category->id }}"> {{ $category->name }}
                                    </li>
                                @endforeach
                            </ul>
                        @endif
                        @if($errors->has('categories'))
                            <span class="text-danger">{{ $errors->first('categories') }}</span>
                        @endif
                    </div>
                    <div class="form-group text-center">
                        <button type="submit" class="btn btn-outline-success btn-lg">{{__('Update post')}}</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-12">
                <div class="d-flex justify-content-between align-items-center mb-3">
                    <h1>{{ __('Posts') }}</h1>
                    <a href="/posts/create" class="btn btn-outline-success">{{ __('Create post') }}</a>
                </div>
                <div class="filters mb-3">
                    <form method="get" action="/posts">
                        <div class="card card-body">
                            <div class="row">
                                <div class="col-5">
                                    <input class="form-control" type="text" name="title" value="{{ request()->title }}" placeholder="{{ __('Post title') }}..." />
                                </div>
                                <div class="col-3">
                                    <input class="form-control" type="text" name="author" value="{{ request()->author }}" placeholder="{{ __('Post author') }}..." />
                                </div>
                                <div class="col-3">
                                    <input class="form-control" type="text" name="date" value="{{ request()->date }}" placeholder="{{ __('Posted after') }}..." />
                                </div>
                                <div class="col-1">
                                    <button type="submit" class="btn btn-success">{{__('Search')}}</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                @if(count($posts))
                    @foreach($posts as $post)
                            <div class="card card-body mb-3 shadow-lg">
                                <a href="/posts/{{ $post->id }}"><h3>{{ $post->title }}</h3></a>
                                <p>{{ $post->preview }}</p>
                                <p><strong>{{ __('Author') }}:</strong> {{ $post->author->name }}</p>
                                <p><strong>{{ __('Created') }}:</strong> {{ $post->created_at->diffForHumans() }}</p>
                                <ul class="list-unstyled list-inline">
                                    @foreach($post->categories as $category)
                                        <li class="list-inline-item">
                                            <a href="/category/{{ $category->slug }}">
                                                <span class="badge badge-primary">{{ $category->name }}</span>
                                            </a>
                                        </li>
                                    @endforeach
                                </ul>
                            </div>
                    @endforeach
                    <div class="pagination">
                        {{ $posts->appends(request()->input())->links() }}
                    </div>
                @else
                    <div class="alert alert-danger mt-5 mb-5">
                        {{__('Nothing here for now. Sorry...')}}
                    </div>
                @endif
            </div>
        </div>
    </div>
@endsection

resources/views/posts/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-12">
                <h1>{{ $post->title }}</h1>
                <ul class="list-unstyled list-inline">
                    @foreach($post->categories as $category)
                        <li class="list-inline-item">
                            <a href="/category/{{ $category->slug }}">
                                <span class="badge badge-primary">{{ $category->name }}</span>
                            </a>
                        </li>
                    @endforeach
                </ul>
                <p>{{ $post->content }}</p>
                <div class="d-flex justify-content-between align-items-center">
                    <div>{{ __('Author') }}: {{ $post->author->name }}</div>
                    <div>{{ __('Created') }}: {{ $post->created_at->diffForHumans() }}({{ $post->created_at->format('H:i:s d M Y') }})</div>
                </div>
            </div>
            <hr />
            <div class="col-12">
                <h2 class="mt-5">{{__('Comments')}}</h2>
                @foreach($post->parent_comments as $comment)
                    <div class="card card-body mb-3">
                        <div class="d-flex justify-content-between align-items-center">
                            <span>{{ $comment->text }} {{ ($comment->parent) }}</span>
                            <span>
                                <ul class="list-inline m-0">
                                    @if($comment->commentWasLiked)
                                        <li class="list-inline-item">{{ $comment->likes->count() }} <a href="/comments/{{ $comment->id }}/unlike" class="text-danger"><i class="fas fa-heart"></i></a></li>
                                    @else
                                        <li class="list-inline-item">{{ $comment->likes->count() }} <a href="/comments/{{ $comment->id }}/like" class="text-danger"><i class="far fa-heart"></i></a></li>
                                    @endif
                                    <li class="list-inline-item"><a href="/comments/{{ $post->id }}/parent/{{ $comment->id }}">{{__('Comment')}}</a></li>
                                </ul>
                            </span>
                        </div>
                    </div>
                    @if($comment->children->count())
                        @foreach($comment->children as $child)
                            <div class="card card-body mb-3 ml-5">
                                <div class="d-flex justify-content-between align-items-center">
                                    <span>{{ $child->text }} {{ ($child->parent) }}</span>
                                    <span>
                                        <ul class="list-inline m-0">
                                            @if($child->commentWasLiked)
                                                <li class="list-inline-item">{{ $child->likes->count() }} <a href="/comments/{{ $child->id }}/unlike" class="text-danger"><i class="fas fa-heart"></i></a></li>
                                            @else
                                                <li class="list-inline-item">{{ $child->likes->count() }} <a href="/comments/{{ $child->id }}/like" class="text-danger"><i class="far fa-heart"></i></a></li>
                                            @endif
                                        </ul>
                                    </span>
                                </div>
                            </div>
                        @endforeach
                    @endif
                @endforeach
                @auth
                    <div class="card card-body shadow-lg">
                        <form method="post" action="/comments/{{ $post->id }}">
                            @csrf
                            <div class="form-group">
                                <textarea name="comment" id="comment" class="form-control" placeholder="{{__('Enter your comment here...')}}"></textarea>
                                @if($errors->has('comment'))
                                    <span class="text-danger">{{ $errors->first('comment') }}</span>
                                @endif
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-outline-primary">{{__('Save comment')}}</button>
                            </div>
                        </form>
                    </div>
                @endauth
            </div>
        </div>
    </div>
@endsection